import 'package:hub/commons/actions/api_manager.dart';

import '/commons/widgets/flutter_flow_util.dart';
import '/commons/widgets/request_manager.dart';

import 'widget.dart' show MessageHistoryPageWidget;
import 'package:flutter/material.dart';

class MessageHistoryPageModel extends FlutterFlowModel<MessageHistoryPageWidget> {
  ///  State fields for stateful widgets in this page.
  /// 
  
  //copyWith

  final unfocusNode = FocusNode();
  // State field(s) for TextField widget.
  FocusNode? textFieldFocusNode;
  TextEditingController? textController;
  String? Function(BuildContext, String?)? textControllerValidator;

  TabController? tabBarController;
  int get tabBarCurrentIndex =>
      tabBarController != null ? tabBarController!.index : 0;

  /// Query cache managers for this widget.

  final _getLiberationsManager = StreamRequestManager<ApiCallResponse>();
  Stream<ApiCallResponse> getLiberations({
    String? uniqueQueryKey,
    bool? overrideCache,
    required Stream<ApiCallResponse> Function() requestFn,
  }) =>
      _getLiberationsManager.performRequest(
        uniqueQueryKey: uniqueQueryKey,
        overrideCache: overrideCache,
        requestFn: requestFn,
      );
  void clearGetLiberationsCache() => _getLiberationsManager.clear();
  void clearGetLiberationsCacheKey(String? uniqueKey) =>
      _getLiberationsManager.clearRequest(uniqueKey);

  @override
  void initState(BuildContext context) {}

  @override
  void dispose() {
    unfocusNode.dispose();
    textFieldFocusNode?.dispose();
    textController?.dispose();
    tabBarController?.dispose();


    /// Dispose query cache managers for this widget.

    clearGetLiberationsCache();
  }
}
