
import 'package:hub/commons/components/atoms/local_header/model.dart';
import 'package:hub/commons/components/molecules/message_well/model.dart';
import 'package:hub/commons/components/organisms/menu/model.dart';
import 'package:hub/modals/filters/selections/widget.dart';



import '/commons/widgets/flutter_flow_util.dart';
import 'widget.dart' show HomePageWidget;
import 'package:flutter/material.dart';

class HomePageModel extends FlutterFlowModel<HomePageWidget> {
  ///  Local state fields for this page.

  bool isGrid = false;

  ///  State fields for stateful widgets in this page.

  final unfocusNode = FocusNode();
  // State field(s) for TextField widget.
  FocusNode? textFieldFocusNode;
  TextEditingController? textController;
  String? Function(BuildContext, String?)? textControllerValidator;
  // Model for localComponent.
  late LocalProfileComponentModel localComponentModel;
  // Model for menuComponent component.
  late MenuComponentModel menuComponentModel;
  // Model for messageWellComponent component.
  late MessageWellComponentModel messageWellComponentModel;

  @override
  void initState(BuildContext context) {
    localComponentModel =
        createModel(context, () => LocalProfileComponentModel());
    menuComponentModel = createModel(context, () => MenuComponentModel());
    messageWellComponentModel =
        createModel(context, () => MessageWellComponentModel());
  }

  @override
  void dispose() {
    unfocusNode.dispose();
    textFieldFocusNode?.dispose();
    textController?.dispose();

    localComponentModel.dispose();
    menuComponentModel.dispose();
    messageWellComponentModel.dispose();
  }


}
